apiVersion: apisix.apache.org/v2
kind: ApisixRoute
metadata:
  name: {{ .Values.contextPath }}-route
spec:
  http:
    - name: {{ .Values.contextPath }}
      match:
        paths:
          - /{{ .Values.contextPath }}/
      backends:
        - serviceName: {{ .Values.serviceName }}
          servicePort: 80
      plugins:
        - name: proxy-rewrite
          enable: true
          config:
            regex_uri:
              - /{{ .Values.contextPath }}/(.*)
              - /$1
            headers:
              X-Forwarded-Prefix: /{{ .Values.contextPath }}
    - name: {{ .Values.contextPath }}-static-resource
      match:
        paths:
          - /{{ .Values.contextPath }}/eureka/*
      backends:
        - serviceName: {{ .Values.serviceName }}
          servicePort: 80
      plugins:
        - name: proxy-rewrite
          enable: true
          config:
            regex_uri:
              - /{{ .Values.contextPath }}/(.*)
              - /$1
            #removed x-forwarded-prefix, seems spring eureka has bug with this header
              #try: curl 'http://api.apisix.local/eureka-service/eureka/css/wro.css'
              #and try: curl 'http://api.apisix.local/eureka-service/eureka/css/wro.css' -H 'x-forwarded-prefix: /eureka-service'
        - name: openid-connect
          enable: {{ .Values.openid.enabled }}
          config:
            client_id: {{ .Values.openid.client_id }}
            client_secret: {{ .Values.openid.client_secret }}
            scope: openid profile
            bearer_only: true
            realm: {{ .Values.openid.realm }}
            introspection_endpoint_auth_method: "client_secret_post"
            discovery: {{ .Values.openid.discovery }}
            introspection_endpoint: {{.Values.openid.introspection_endpoint}}

  {{/*apiVersion: networking.k8s.io/v1*/}}
{{/*kind: Ingress*/}}
{{/*metadata:*/}}
{{/*  name: {{ .Values.contextPath }}-ingress*/}}
{{/*  annotations:*/}}
{{/*    nginx.ingress.kubernetes.io/x-forwarded-prefix: /{{ .Values.contextPath }}*/}}
{{/*    k8s.apisix.apache.org/rewrite-target-regex: "/{{ .Values.contextPath }}/(.*)"*/}}
{{/*    k8s.apisix.apache.org/rewrite-target-regex-template: "/$1"*/}}
{{/*spec:*/}}
{{/*  ingressClassName: apisix*/}}
{{/*  rules:*/}}
{{/*    - http:*/}}
{{/*        paths:*/}}
{{/*          - path: /{{ .Values.contextPath }}*/}}
{{/*            pathType: Prefix*/}}
{{/*            backend:*/}}
{{/*              service:*/}}
{{/*                name: {{ .Values.contextPath }}*/}}
{{/*                port:*/}}
{{/*                  number: 80*/}}